/************************************************************************************
  This is your background code.
  For more information please visit our wiki site:
  http://docs.crossrider.com/#!/guide/scopes_background
*************************************************************************************/

appAPI.ready(function($) {
  var _hknURL = 'http://www2.helfen-kostet-nix.de';
  var _shopsURL = _hknURL + '/shops/shops_json';
  var _shops = {};
  var _retryTimeout = 2000;
  var _retryMaxCount = 10;

  init();

	function init() {
        appAPI.db.removeAll();
        initBrowserAction();
        getShops();
    }

	function initBrowserAction() {
        appAPI.browserAction.setResourceIcon('img/icon48.png');
        appAPI.browserAction.setTitle('Helfen kostet nix');
        appAPI.browserAction.onClick(function () {
            appAPI.message.toActiveTab({action: 'browserActionClicked'});
        });
    }
	
	function getShops() {
        initShops(_retryMaxCount, function (success) {
        });
    }
    
    function initShops(retry, callback) {

        if (!appAPI.utils.isDefined(retry)) {
            retry = _retryMaxCount;
        }

        appAPI.db.async.get("shops", function (shops) {
                appAPI.db.async.setFromRemote(
                    _shopsURL,
                    "shops",
                    appAPI.time.daysFromNow(1),
                    function (response) {
                        _shops = appAPI.JSON.parse(response);
                        if (appAPI.utils.isDefined(callback)) {
                            callback(true);
                        }
                    },
                    function (httpCode) {
                        if (retry > 0) {
                            appAPI.setTimeout(function () {
                                retry = retry - 1;
                                initShops(retry);
                            }, _retryTimeout);
                        }
                        else {
                            if (appAPI.utils.isDefined(callback)) {
                                callback(false);
                            }
                        }
                    }
                );
            
        });
    }
    
});
